// Consumer
#include "ipc.h"

int main()
{
	// Open the shared memory
	int fd = shm_open(mmap_filename,O_RDWR, S_IRWXU | S_IRWXG | S_IRWXO);
	if (fd < 0)
	{
		perror("shm_open");
		return 0;
	}

	// Memory map it so it looks like memory
	void * buf = mmap(0,szmmap, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0);

	// Shared variable, write index
	unsigned volatile int * write_idx = (unsigned int*) ((unsigned long)buf + szbuf);
	// Shared variable, read index
	unsigned volatile int * read_idx = (unsigned int*) ((unsigned long)buf + szbuf + sizeof(unsigned int));

	printf("first int:%d\n",*(char*)buf);
	while (1)
	{
#ifndef NDEBUG
		printf("write:%d\t",*write_idx);
		printf("read:%d\t",*read_idx);
		printf("count:%d\t",CIRC_CNT(*write_idx,*read_idx,szbuf));
		printf("space:%d\t",CIRC_SPACE(*write_idx,*read_idx,szbuf));
#endif

		// Wait for the producer to produce an int
		while(CIRC_CNT(*write_idx,*read_idx,szbuf)<sizeof(int));

		// Read the next int
		int x;
		x = *(int*)((unsigned long)buf + *read_idx);

		// Fence it off so that the order of reading and incrementing the read
		// pointer doesn't get switched
		smp_wmb();

		// Increment the read pointer and modulo szbuf
		*read_idx = (*read_idx + sizeof(int)) & (szbuf - 1);
#ifndef NDEBUG
		// Print what we read!
		printf("x:%d\n",x);
#endif

		// Break when receive a zero
		if (!x) break;
	}
	munmap(buf,szmmap);
	shm_unlink(mmap_filename);
}

